import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

public class UtcDetachTest {

	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence
				.createEntityManagerFactory("objectdb:db/test.tmp;drop");
		EntityManager em = emf.createEntityManager();

		// load data
		em.getTransaction().begin();
		for (int i = 0; i < 10; i++) {
			B bObj = new B();
			em.persist(bObj);
			for (int x = 0; x < 10; x++) {
				A aObj = new A(bObj);
				em.persist(aObj);
			}
		}
		em.getTransaction().commit();
		em.clear();
		
		// select all b classes with join fetch
		String q = "select b from B b join fetch b.aClasses";
		TypedQuery<B> bQuery = em.createQuery(q, B.class);
		List<B> bResult = bQuery.getResultList();
		em.close();

		for (B bObj : bResult) {
			System.out
					.println("A objects in B is null? " + (bObj.aClasses == null));
		}

		emf.close();
	}

	@Entity
	public static class A {
		@ManyToOne
		B bClasse;

		public A(B bClasse) {
			super();
			this.bClasse = bClasse;
		}
	}

	@Entity
	public static class B {
		@OneToMany(fetch = FetchType.LAZY, cascade = CascadeType.ALL, mappedBy = "bClasse")
		List<A> aClasses = new ArrayList<A>();
	}
}
